<template>
  <router-view />
</template>

<script lang="ts" setup>
import { useAppStore } from '@/store/app'
import { onMounted } from 'vue'
import { useDataStore } from './store/data'

const app = useAppStore()
const data = useDataStore()

const intervalWaitingForMain = setInterval(applyInnerHeight, 200)
/*
  HACK: this section enables the main section of the app to
        resize to its true size on mobile devices. The browser
        doesn't provide a CSS property for the height without the
        navigation bar.
  Two triggers :
    - every 200ms until main is defined and if so, update its max-height
    - on window resize, recompute the max-height
 */
function applyInnerHeight() {
  const main = document.getElementsByClassName('v-main')[0] as HTMLElement
  if (!main) return
  main.style.maxHeight = `${window.innerHeight}px`
  clearInterval(intervalWaitingForMain)
}

window.onresize = () => {
  const isDesktop = window.innerWidth > 1024
  if (isDesktop !== app.isDesktop) {
    app.toggleDrawer(isDesktop)
  }
  app.isDesktop = isDesktop
  applyInnerHeight()
}

onMounted(async () => {
  const api = await data.bc
  api.isReadyOrError.then(() => {
    console.log('Connection with blockchain ready !')
  }).catch(err => {
    console.error('Failed to establish connection with blockchain: ', err)
  })
})
</script>
